precision highp float;

uniform vec3 scaler; 
uniform vec3 transer;
uniform float eye;
uniform mat4 quat;
attribute vec3 vPosition;
attribute vec2 vTex_coord;
attribute vec3 vNormal;
varying vec3 tex_coord;
varying vec3 tex_normal;

float rand(vec2 co) {
 return fract(sin(dot(co.xy, vec2(12.9898, 78.233)))*43758.5453);
}

void main() {
 vec4 pos;

 pos = vec4(vPosition, 1.0);

 pos *= vec4(scaler.xyz, 1.0);


 pos+= transer;

 pos *= quat;

// pos.x += rand(pos.xy)/3.0;

 pos.x += (eye/(pos.z));
 
 gl_Position = vec4(pos.xyz,  pos.z * -1.0); 
 tex_coord = vec3(vTex_coord, pos.z); 
 tex_normal = vNormal;
} 

