precision highp float;

uniform sampler2D tex;
uniform float alpha_mult;
uniform float time;
uniform int blend_z;
varying vec3 tex_coord;
varying vec3 tex_normal;

void main(void) {
 float c;

 vec4 color = texture2D(tex, tex_coord.xy);


 if(tex_coord.z > -1.1)
  discard;
 else 
  gl_FragColor=color * vec4(1.0,1.0,1.0, alpha_mult);
}

