precision highp float;

uniform sampler2D tex;
uniform float alpha_mult;
uniform float time;
uniform int blend_z;
varying vec3 tex_coord;
varying vec3 tex_normal;

void main(void) {
 float c;

 vec3 color = vec3(80.0/256.0, 68.0/256.0, 178.0/256.0);

 c = dot(vec3(1.0, 0.0, 0.0), tex_normal);

 if(tex_coord.z > -1.1)
  discard;
 else 
  gl_FragColor=vec4(color*c, alpha_mult);
}

